//
//  AnagogSDKWrapper+DeprecatedMethods.swift
//
//  Copyright © 2022 Anagog Ltd. All rights reserved.
//

import Foundation
import JedAIAppKit

@objc
public class JedAIAppWrapper: NSObject {
    @objc
    public static let shared = AnagogSDKWrapper.shared
}

@objc
public class AnagogReactNative: NSObject {
    @objc
    public static let shared = AnagogSDKWrapper.shared
}

@objc
public extension AnagogSDKWrapper {
    
    // MARK: - Startup
    
    // API upto v1.3.8
    
    @objc
    @available(*, deprecated)
    func applicationDidFinishLaunching(withOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]) {
        self.launchOptions = launchOptions
    }
    
    // API upto v1.6.0
    
    @objc
    @available(*, deprecated)
    func start() {
        self.startup()
    }
    
    @objc
    @available(*, deprecated)
    func start(withApiKey apiKey: String? = nil, configurationFileURL: URL? = nil) {
        if let url = configurationFileURL {
            Self.configurationFileURL = url
        }
        self.startup(withAPIKey: apiKey)
    }
    
    // MARK: - Configuration
    
    @objc(setAPIKey:)
    @available(*, deprecated)
    func set(apiKey: String) {
        JedAIApp.apiKey = apiKey
    }
    
    @objc(setRemoteNotificationsServiceEndpoint:)
    @available(*, deprecated)
    func set(remoteNotificationsServiceEndpoint: String) {
        Self.optionsHandler.deprecatedIntegrationConfigs["core.remoteNotificationsServiceEndpoint"] = remoteNotificationsServiceEndpoint
    }
    
    @objc
    @available(*, deprecated)
    func disableRemoteNotifications() {
        Self.optionsHandler.deprecatedIntegrationConfigs["enableRemoteNotifications"] = false
    }
    
    @objc
    @available(*, deprecated)
    func disableCrashReports() {
        Self.optionsHandler.deprecatedIntegrationConfigs["enableCrashReports"] = false
    }
    
    @objc
    @available(*, deprecated)
    func disableAudienceAnalytics() {
        Self.optionsHandler.deprecatedIntegrationConfigs["enableAudienceAnalytics"] = false
    }
    
    @objc
    @available(*, deprecated)
    func enableAudienceAnalytics() {
        Self.optionsHandler.deprecatedIntegrationConfigs["enableAudienceAnalytics"] = true
    }
    
    @objc
    @available(*, deprecated)
    func enableDevelopmentMode() {
        Self.optionsHandler.deprecatedIntegrationConfigs["enableInternalLog"] = true
    }
    
}
