//
//  SwiftAnagogFlutterPlugin.swift
//
//  Copyright © 2022 Anagog Ltd. All rights reserved.
//

import Flutter
import Foundation
import JedAIKit
import JedAIJEMAKit
import JedAIMetricsKit
import JedAIReportKit
import CoreMotion
import CoreLocation

public class SwiftAnagogFlutterPlugin: NSObject, FlutterPlugin {
    
    private static let methodsChannelName = "com.anagog.flutter/method_channel"
    
    public static func register(with registrar: FlutterPluginRegistrar) {
        let instance = SwiftAnagogFlutterPlugin()
        let channel = FlutterMethodChannel(name: methodsChannelName, binaryMessenger: registrar.messenger())
        
        registrar.addApplicationDelegate(instance)
        registrar.addMethodCallDelegate(instance, channel: channel)
        EventEmitter.register(with: registrar)
    }
    
    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        JedAIBridge.handle(call, result: result)
    }
    
}

extension SwiftAnagogFlutterPlugin: FlutterApplicationLifeCycleDelegate {
    
    public func applicationWillTerminate(_ application: UIApplication) {
        EventEmitter.unregister()
    }
    
    public func application(_ application: UIApplication, didRegisterForRemoteNotificationsWithDeviceToken deviceToken: Data) {
        JedAIAppWrapper.shared.updateDeviceToken(deviceToken)
    }
    
    public func application(_ application: UIApplication, didFailToRegisterForRemoteNotificationsWithError error: Error) {
    }
    
    public func application(_ application: UIApplication, didReceiveRemoteNotification userInfo: [AnyHashable : Any], fetchCompletionHandler completionHandler: @escaping (UIBackgroundFetchResult) -> Void) -> Bool {
        JedAIAppWrapper.shared.didReceiveRemoteNotification(userInfo)
        if let _ = userInfo["com.anagog.jedai.notification.source"] {
            completionHandler(.newData)
            return true
        }
        return false
    }
    
}
