import 'package:anagog_flutter/platform_interface/anagog_flutter_platform_interface.dart';

abstract class AnagogFlutterOnboarding {
  ///Announce JedAI SDK that app onboarding started
  Future start();

  ///Announce JedAI SDK that app onboarding completed
  Future complete();

  ///Announce JedAI SDK that onboarding already completed
  Future markAsCompleted();

  ///Reset onboarding status
  Future reset();
}

class OnBoardingImpl implements AnagogFlutterOnboarding {
  ///Announce JedAI SDK that app onboarding started
  @override
  Future start() async => AnagogFlutterPlatform.onboarding.start();

  ///Announce JedAI SDK that app onboarding completed
  @override
  Future complete() async => AnagogFlutterPlatform.onboarding.complete();

  ///Announce JedAI SDK that onboarding already completed
  @override
  Future markAsCompleted() async =>
      AnagogFlutterPlatform.onboarding.markAsCompleted();

  ///Reset onboarding status
  @override
  Future reset() async => AnagogFlutterPlatform.onboarding.reset();
}
